#include "stdafx.h"

#define TENA_PLATFORM xp-vc71-d

#include <TENA/Middleware/Config.h>
#include <TASEmulatorPublisherSingleton.h>

#include <osg/Node>
#include <osg/Group>
#include <osg/Geode>
#include <osg/Notify>
#include <osg/Geometry>
#include <osg/Texture2D>
#include <osgDB/ReadFile>
#include <osgDB/FileUtils>
#include <osgProducer/Viewer>
#include <osg/PositionAttitudeTransform>

#include <osgText/Font>
#include <osgText/Text>
#include <osg/MatrixTransform>

#include <osg/Projection>
#include <osg/ShapeDrawable>

#include <osgDB/WriteFile>

#include <osg/StateSet>
#include <osg/Texture2D>
#include <osg/TexEnv>
#include <osg/TexGen>
#include <osg/ShapeDrawable>
#include "KeyboardHandler.h"
#include "orientation.h"


char tempstr[] = "                                        ";


#define MYBUFSIZE 32768
#define DEFAULT_MULTICAST_ADDR "224.9.9.2"

#include "ace/OS.h"
#include "ace/Log_Msg.h"
#include "ace/INET_Addr.h"
#include "ace/SOCK_Dgram_Mcast.h"
/* 
   Use the typical TCP/IP port address for receiving datagrams. 
 */ 
static const u_short PORT = ACE_DEFAULT_SERVER_PORT; 
/* 
       This is where we'll listen for datagrams coming from the 
       clients.  We'll give this address to the open() method 
       below to enable the listener. 
     */ 
ACE_INET_Addr  local(PORT); 

    /* 
       A simply constructed datagram that we'll listen with. 
     */ 
ACE_SOCK_Dgram_Mcast mcast_dgram_;
ACE_INET_Addr remote((u_short)0);
ACE_INET_Addr mcast_addr_(2000,DEFAULT_MULTICAST_ADDR);
BYTE bytebuf[MYBUFSIZE];
ssize_t recv_count;

long data_counter = 0;

double gMFCfieldOfView;
extern int globalOSGPanValue; //this is the value from the Pan slider
extern int globalOSGTiltValue; //this is the value from the Tilt slider

#define TIMEOUT 5

#define XOFFSET_MOUT0 760.0
#define YOFFSET_MOUT0 1570.0
#define ZOFFSET_MOUT0 187.50

// CxImage
#include "ximage.h"
#include "ximagif.h"
#include "ximatif.h"
#include "xfile.h"

CxImage  myimage;

osg::Texture2D* sceneTexture = new osg::Texture2D();
osg::Texture2D* KLN89FaceTexture = new osg::Texture2D;
Producer::CameraConfig* myCameraConfig = new Producer::CameraConfig();
Producer::Camera* tankFollowerCamera = new Producer::Camera();
Producer::Camera* mainCamera = new Producer::Camera();
int firsttime = 0;
long icount = 0;
bool bLockOn = false;

// Matrix transform node for positioning HUD:
osg::PositionAttitudeTransform* HUDXform;
osg::PositionAttitudeTransform* HUDXform2;
osg::PositionAttitudeTransform* HUDXform3;
// Position of HUD(s):
osg::Vec3 HUDPosit;
osg::Vec3 HUDPosit2;
osg::Vec3 HUDPosit3;
osg::Geode* MyGeode = new osg::Geode();      // copy of HUD geode for crosshairs
osg::Geode* MyGeode2 = new osg::Geode();     // copy of HUD geode for reticules
osg::Geode* MyGeode3 = new osg::Geode();     // copy of HUD geode for static symbology


//TENA Vars
RTTC::TA2PublisherImpl::Platform platform;
RTTC::TA2PublisherImpl::TASemulator TAS_;
RTTC::TA2PublisherImpl::SceneGenerator sceneGenerator;


  class CaptureImageCallback : public Producer::Camera::Callback
{
    public:
        void operator () (const Producer::Camera &cam )
        {
            
            
			//osg::ref_ptr<osg::Image>image = new osg::Image;

			osg::Image* image = new osg::Image;
			image->allocateImage( 512, 256, 1, GL_RGB, GL_UNSIGNED_BYTE);
			//image->readPixels( 258, 40, 760, 700, GL_RGB, GL_UNSIGNED_BYTE);
			unsigned int filesize = image->getTotalSizeInBytes();

			unsigned char *myArray;
			//unsigned char myArray[MYBUFSIZE];
			myArray = image->data();
			BYTE bytebuf[MYBUFSIZE];
			//BYTE *bytebuf = 0;
			//bytebuf = image->data();
  
			
				//DWORD dwBytesWritten = clientPipe.Read((LPVOID) myArray, filesize, NULL);
//			    r_bytes = ACE_OS::recv (n_handle, (char *)myArray, BUFSIZ); //was filesize
				//recv_count = dgram.recv((char *)myArray,sizeof(myArray),remote);
				//recv_count = dgram.recv(&bytebuf,sizeof(bytebuf),remote);
				recv_count = mcast_dgram_.recv(&bytebuf,sizeof(bytebuf),local);
				 if (icount%100 == 0)
				    printf("************* recv_count - %d\n",recv_count);
				 icount++;
				CxImage mimage(bytebuf,recv_count,CXIMAGE_FORMAT_JPG);
				mimage.Save("b:\\image2.jpg",CXIMAGE_FORMAT_JPG);
				osg::Image* klnFace  = osgDB::readImageFile("b:\\image2.jpg");
			
				if (recv_count > 0) KLN89FaceTexture->setImage(klnFace);
				//free(bytebuf);
				mimage.Destroy();
        }
};

  Producer::CameraConfig* setupCameras()
{
  // Producer::CameraConfig* myCameraConfig = new Producer::CameraConfig();
  // Producer::Camera* tankFollowerCamera = new Producer::Camera();
  // Producer::Camera* mainCamera = new Producer::Camera();

//   mainCamera->setProjectionRectangle(0.25f, 0.75f, 0.0f, 0.5f);
//   mainCamera->setShareLens(false);
//   mainCamera->getLens()->setAutoAspect(true);

   tankFollowerCamera->setProjectionRectangle(0.0f, 1.0f, 0.0f, 1.0f);
   tankFollowerCamera->setShareLens(false);
   tankFollowerCamera->getLens()->setAutoAspect(true);

   myCameraConfig->addCamera("tankFollowerCamera",tankFollowerCamera);
  // myCameraConfig->addCamera("mainCamera",mainCamera);

   Producer::RenderSurface* rsOne = mainCamera->getRenderSurface();
   tankFollowerCamera->setRenderSurface( rsOne );
   rsOne->setWindowName("TA2 TAS Emulator     Trideum Corp.");
   rsOne->setWindowRectangle(20,250,512,512);
   return myCameraConfig;
}

/** create quad at specified position. */
osg::Drawable* createSquare(const osg::Vec3& corner,const osg::Vec3& width,const osg::Vec3& height, osg::Image* image=NULL)
{
    // set up the Geometry.
    osg::Geometry* geom = new osg::Geometry;

    osg::Vec3Array* coords = new osg::Vec3Array(4);
    (*coords)[0] = corner;
    (*coords)[1] = corner+width;
    (*coords)[2] = corner+width+height;
    (*coords)[3] = corner+height;


    geom->setVertexArray(coords);

    osg::Vec3Array* norms = new osg::Vec3Array(1);
    (*norms)[0] = width^height;
    (*norms)[0].normalize();
    
    geom->setNormalArray(norms);
    geom->setNormalBinding(osg::Geometry::BIND_OVERALL);

    osg::Vec2Array* tcoords = new osg::Vec2Array(4);
    (*tcoords)[0].set(0.0f,0.0f);
    (*tcoords)[1].set(1.0f,0.0f);
    (*tcoords)[2].set(1.0f,1.0f);
    (*tcoords)[3].set(0.0f,1.0f);
    geom->setTexCoordArray(0,tcoords);
    
    geom->addPrimitiveSet(new osg::DrawArrays(osg::PrimitiveSet::QUADS,0,4));
    
    if (image)
    {
        osg::StateSet* stateset = new osg::StateSet;
        osg::Texture2D* texture = new osg::Texture2D;
        texture->setImage(image);
        stateset->setTextureAttributeAndModes(0,texture,osg::StateAttribute::ON);
        geom->setStateSet(stateset);
    }
    
    return geom;
}
// Routine to toggle Cross hairs and other symbology On/Off
void LockOrUnlock(void)
{

	if (bLockOn) {
		bLockOn = false;
		MyGeode->setNodeMask(0); 
	}
	else {
		bLockOn = true;
		MyGeode->setNodeMask(~0); 
	}
}

void UpdateTSPI(void)
{
	// get current tspi from joystick app
	platform = TAS_EMULATOR_PUBLISHER->GetPlatform();

	// convert to three Eulers to be able to pass thru TENA
	double psi, theta, phi;
	Orientation::Quaternian_to_Euler(platform.quatW, platform.quatX, platform.quatY, platform.quatZ, psi, theta, phi);
			

	// set values to be published out to scene generator
	TAS_.fieldOfView = 90;
	gMFCfieldOfView = TAS_.fieldOfView;
	TAS_.terrainID = 101;
	TAS_.viewFromX = platform.posX;
	TAS_.viewFromY = platform.posY;
	TAS_.viewFromZ = platform.posZ;
// because of omissions in OM, these three vars are used to pass orientation in Euler angles
	TAS_.viewRotationAngle = psi-(osg::DegreesToRadians((double)globalOSGPanValue)); //was + per KK 10-23-06
	TAS_.viewToX = theta;
	TAS_.viewToY = phi+(osg::DegreesToRadians((double)globalOSGTiltValue));

	TAS_.zoomFactor = 1.0;

	TAS_EMULATOR_PUBLISHER->UpdateTAS(TAS_);
	sceneGenerator = TAS_EMULATOR_PUBLISHER->GetSceneGenerator();
}


//int main( int argc, char **argv )
//int ACE_TMAIN(int argc, ACE_TCHAR *argv[])
void OSG_Module(void)
{
   //osgProducer::Viewer viewer;
   // Text instance for HUD:
   osgText::Text* textOne = new osgText::Text();  // IRIG time display
   // Declare a group to act as root node of a scene:
   osg::Group* root = new osg::Group();

   osgDB::FilePathList pathList = osgDB::getDataFilePathList();
   pathList.push_back("C:\\OSG1\\NPS_Tutorials\\NPSData\\Textures\\");
   pathList.push_back("C:\\TA2\\Textures\\");
   
   osgDB::setDataFilePathList(pathList);

    // add the drawable into a single goede to be shared...
    osg::Billboard* center = new osg::Billboard();
    center->setMode(osg::Billboard::POINT_ROT_EYE);
    center->addDrawable(
        createSquare(osg::Vec3(-0.5f,0.0f,-0.5f),osg::Vec3(2.0f,0.0f,0.0f),osg::Vec3(0.0f,0.0f,1.0f),osgDB::readImageFile("b:\\image2.jpg")),
        osg::Vec3(0.0f,0.0f,0.0f));
	//root->addChild(center);

    // A geometry node for our HUD(s):
   osg::Geode* HUDGeode = new osg::Geode();
   osg::Geode* HUDGeode2 = new osg::Geode();
   osg::Geode* HUDGeode3 = new osg::Geode();
   // Projection nodes for defining view frustrum for HUD(s):
   osg::Projection* HUDProjectionMatrix = new osg::Projection;
   osg::Projection* HUDProjectionMatrix2 = new osg::Projection;
   osg::Projection* HUDProjectionMatrix3 = new osg::Projection;
   // Initialize the projection matrix for viewing everything we
   // will add as descendents of this node. Use screen coordinates
   // to define the horizontal and vertical extent of the projection
   // matrix. Positions described under this node will equate to
   // pixel coordinates.
   HUDProjectionMatrix->setMatrix(osg::Matrix::ortho2D(0,512,0,512));
   HUDProjectionMatrix2->setMatrix(osg::Matrix::ortho2D(0,512,0,512));
   HUDProjectionMatrix3->setMatrix(osg::Matrix::ortho2D(0,512,0,512));
   // For the HUD model view matrix use an identity matrix:
   osg::MatrixTransform* HUDModelViewMatrix = new osg::MatrixTransform;
   HUDModelViewMatrix->setMatrix(osg::Matrix::identity());
   osg::MatrixTransform* HUDModelViewMatrix2 = new osg::MatrixTransform;
   HUDModelViewMatrix2->setMatrix(osg::Matrix::identity());
   osg::MatrixTransform* HUDModelViewMatrix3 = new osg::MatrixTransform;
   HUDModelViewMatrix3->setMatrix(osg::Matrix::identity());
   // Make sure the model view matrix is not affected by any transforms
   // above it in the scene graph:
   HUDModelViewMatrix->setReferenceFrame(osg::Transform::ABSOLUTE_RF);
   HUDModelViewMatrix2->setReferenceFrame(osg::Transform::ABSOLUTE_RF);
   HUDModelViewMatrix3->setReferenceFrame(osg::Transform::ABSOLUTE_RF);
    // Add the HUD projection matrix as a child of the root node
   // and the HUD model view matrix as a child of the projection matrix
   // Anything under this node will be view using this projection matrix
   // and positioned with this model view matrix.
   root->addChild(HUDProjectionMatrix);
   root->addChild(HUDProjectionMatrix2);
   root->addChild(HUDProjectionMatrix3);
   HUDProjectionMatrix->addChild(HUDModelViewMatrix);
   HUDProjectionMatrix->addChild(HUDModelViewMatrix2);
   HUDProjectionMatrix->addChild(HUDModelViewMatrix3);
   // Add the Geometry node to contain HUD geometry as a child of the
   // HUD model view matrix.
   // (See figure "n")
   HUDXform = new osg::PositionAttitudeTransform();
   HUDPosit.set(0,1.5,1.0);
   HUDXform->setPosition( HUDPosit );
   HUDModelViewMatrix->addChild( HUDXform );
   HUDXform->addChild( HUDGeode );

   HUDXform2 = new osg::PositionAttitudeTransform();
   HUDPosit2.set(0,1.5,1.0);
   HUDXform2->setPosition( HUDPosit2 );
   HUDModelViewMatrix2->addChild( HUDXform2 );
   HUDXform2->addChild( HUDGeode2 );

   HUDXform3 = new osg::PositionAttitudeTransform();
   HUDPosit3.set(0,1.5,1.0);
   HUDXform3->setPosition( HUDPosit3 );
   HUDModelViewMatrix2->addChild( HUDXform3 );
   HUDXform3->addChild( HUDGeode3 );

   // Add the text (Text class is derived from drawable) to the geode:
   HUDGeode->addDrawable( textOne );
   // Set up the parameters for the text we'll add to the HUD:
   textOne->setCharacterSize(15);
   textOne->setFont("C:/TA2/Arcade_Interlaced.ttf"); 
   textOne->setText("180:12:43:56.189");
   textOne->setAxisAlignment(osgText::Text::SCREEN);
   textOne->setPosition( osg::Vec3(50,450,-1.5) );
   textOne->setColor( osg::Vec4(199,199, 15, 1) );
   // Set up geometry for the HUD and add it to the HUD
   // geometry node, see tutorial "n" for details:
   osg::Geometry* HUDBackgroundGeometry = new osg::Geometry();
    osg::Vec3Array* HUDBackgroundVertices = new osg::Vec3Array;

	osg::Geometry* HUDBackgroundGeometry2 = new osg::Geometry();
    osg::Vec3Array* HUDBackgroundVertices2 = new osg::Vec3Array;

	osg::Geometry* HUDBackgroundGeometry3 = new osg::Geometry();
    osg::Vec3Array* HUDBackgroundVertices3 = new osg::Vec3Array;

   HUDBackgroundVertices->push_back( osg::Vec3( 0, 0,-1) );
   HUDBackgroundVertices->push_back( osg::Vec3(512, 0,-1) );
   HUDBackgroundVertices->push_back( osg::Vec3(512,512,-1) );
   HUDBackgroundVertices->push_back( osg::Vec3( 0,512,-1) );
   osg::DrawElementsUInt* HUDBackgroundIndices =
      new osg::DrawElementsUInt(osg::PrimitiveSet::POLYGON, 0);
   HUDBackgroundIndices->push_back(0);
   HUDBackgroundIndices->push_back(1);
   HUDBackgroundIndices->push_back(2);
   HUDBackgroundIndices->push_back(3);
   osg::Vec4Array* HUDcolors = new osg::Vec4Array;
   HUDcolors->push_back(osg::Vec4(0.8f,0.8f,0.8f,0.8f));

   HUDBackgroundVertices2->push_back( osg::Vec3( 0, 0,-1) );
   HUDBackgroundVertices2->push_back( osg::Vec3(512, 0,-1) );
   HUDBackgroundVertices2->push_back( osg::Vec3(512,512,-1) );
   HUDBackgroundVertices2->push_back( osg::Vec3( 0,512,-1) );
   osg::DrawElementsUInt* HUDBackgroundIndices2 =
      new osg::DrawElementsUInt(osg::PrimitiveSet::POLYGON, 0);
   HUDBackgroundIndices2->push_back(0);
   HUDBackgroundIndices2->push_back(1);
   HUDBackgroundIndices2->push_back(2);
   HUDBackgroundIndices2->push_back(3);
   osg::Vec4Array* HUDcolors2 = new osg::Vec4Array;
   HUDcolors2->push_back(osg::Vec4(0.8f,0.8f,0.8f,0.8f));

   HUDBackgroundVertices3->push_back( osg::Vec3( 0, 0,-1) );
   HUDBackgroundVertices3->push_back( osg::Vec3(512, 0,-1) );
   HUDBackgroundVertices3->push_back( osg::Vec3(512,512,-1) );
   HUDBackgroundVertices3->push_back( osg::Vec3( 0,512,-1) );
   osg::DrawElementsUInt* HUDBackgroundIndices3 =
      new osg::DrawElementsUInt(osg::PrimitiveSet::POLYGON, 0);
   HUDBackgroundIndices3->push_back(0);
   HUDBackgroundIndices3->push_back(1);
   HUDBackgroundIndices3->push_back(2);
   HUDBackgroundIndices3->push_back(3);
   osg::Vec4Array* HUDcolors3 = new osg::Vec4Array;
   HUDcolors3->push_back(osg::Vec4(0.8f,0.8f,0.8f,0.1f));

   osg::Vec2Array* texcoords = new osg::Vec2Array(4);
   (*texcoords)[0].set(0.0f,0.0f);
   (*texcoords)[1].set(1.0f,0.0f);
   (*texcoords)[2].set(1.0f,1.0f);
   (*texcoords)[3].set(0.0f,1.0f);

   HUDBackgroundGeometry->setTexCoordArray(0,texcoords);
   osg::Texture2D* HUDTexture = new osg::Texture2D;
   HUDTexture->setDataVariance(osg::Object::DYNAMIC);
   osg::Image* hudImage;

   HUDBackgroundGeometry2->setTexCoordArray(0,texcoords);
   osg::Texture2D* HUDTexture2 = new osg::Texture2D;
   HUDTexture2->setDataVariance(osg::Object::DYNAMIC);
   osg::Image* hudImage2;

   HUDBackgroundGeometry3->setTexCoordArray(0,texcoords);
   osg::Texture2D* HUDTexture3 = new osg::Texture2D;
   HUDTexture3->setDataVariance(osg::Object::DYNAMIC);
   osg::Image* hudImage3;
   
   hudImage = osgDB::readImageFile("ibas_static2.png");
   HUDTexture->setImage(hudImage);
   osg::Vec3Array* HUDnormals = new osg::Vec3Array;
   HUDnormals->push_back(osg::Vec3(0.0f,0.0f,1.0f));
   HUDBackgroundGeometry->setNormalArray(HUDnormals);
   HUDBackgroundGeometry->setNormalBinding(osg::Geometry::BIND_OVERALL);
   HUDBackgroundGeometry->addPrimitiveSet(HUDBackgroundIndices);
   HUDBackgroundGeometry->setVertexArray(HUDBackgroundVertices);
   HUDBackgroundGeometry->setColorArray(HUDcolors);
   HUDBackgroundGeometry->setColorBinding(osg::Geometry::BIND_OVERALL);
   HUDGeode->addDrawable(HUDBackgroundGeometry);

   hudImage2 = osgDB::readImageFile("reticule2.png");
   HUDTexture2->setImage(hudImage2);
   osg::Vec3Array* HUDnormals2 = new osg::Vec3Array;
   HUDnormals2->push_back(osg::Vec3(0.0f,0.0f,1.0f));
   HUDBackgroundGeometry2->setNormalArray(HUDnormals2);
   HUDBackgroundGeometry2->setNormalBinding(osg::Geometry::BIND_OVERALL);
   HUDBackgroundGeometry2->addPrimitiveSet(HUDBackgroundIndices2);
   HUDBackgroundGeometry2->setVertexArray(HUDBackgroundVertices2);
   HUDBackgroundGeometry2->setColorArray(HUDcolors2);
   HUDBackgroundGeometry2->setColorBinding(osg::Geometry::BIND_OVERALL);
   HUDGeode2->addDrawable(HUDBackgroundGeometry2);

   hudImage3 = osgDB::readImageFile("dummy.png");
   HUDTexture3->setImage(hudImage3);
   osg::Vec3Array* HUDnormals3 = new osg::Vec3Array;
   HUDnormals3->push_back(osg::Vec3(0.0f,0.0f,1.0f));
   HUDBackgroundGeometry3->setNormalArray(HUDnormals3);
   HUDBackgroundGeometry3->setNormalBinding(osg::Geometry::BIND_OVERALL);
   HUDBackgroundGeometry3->addPrimitiveSet(HUDBackgroundIndices3);
   HUDBackgroundGeometry3->setVertexArray(HUDBackgroundVertices3);
   HUDBackgroundGeometry3->setColorArray(HUDcolors3);
   HUDBackgroundGeometry3->setColorBinding(osg::Geometry::BIND_OVERALL);
   HUDGeode3->addDrawable(HUDBackgroundGeometry3);

   osg::StateSet* HUDStateSet = new osg::StateSet();
   HUDGeode->setStateSet(HUDStateSet);
   HUDStateSet->
      setTextureAttributeAndModes(0,HUDTexture,osg::StateAttribute::ON);

   osg::StateSet* HUDStateSet2 = new osg::StateSet();
   HUDGeode2->setStateSet(HUDStateSet2);
   HUDStateSet2->
      setTextureAttributeAndModes(0,HUDTexture2,osg::StateAttribute::ON);

   osg::StateSet* HUDStateSet3 = new osg::StateSet();
   HUDGeode3->setStateSet(HUDStateSet3);
   HUDStateSet3->
      setTextureAttributeAndModes(0,HUDTexture3,osg::StateAttribute::ON);

   // For this state set, turn blending on (so alpha texture looks right)
   HUDStateSet->setMode(GL_BLEND,osg::StateAttribute::ON);
   HUDStateSet2->setMode(GL_BLEND,osg::StateAttribute::ON);
   HUDStateSet3->setMode(GL_BLEND,osg::StateAttribute::ON);

   // Disable depth testing so geometry is draw regardless of depth values
   // of geometry already draw.
   HUDStateSet->setMode(GL_DEPTH_TEST,osg::StateAttribute::OFF);
   HUDStateSet->setRenderingHint( osg::StateSet::TRANSPARENT_BIN );

   HUDStateSet2->setMode(GL_DEPTH_TEST,osg::StateAttribute::OFF);
   HUDStateSet2->setRenderingHint( osg::StateSet::TRANSPARENT_BIN );

   HUDStateSet3->setMode(GL_DEPTH_TEST,osg::StateAttribute::OFF);
   HUDStateSet3->setRenderingHint( osg::StateSet::TRANSPARENT_BIN );

   // Need to make sure this geometry is drawn last. RenderBins are handled
   // in numerical order so set bin number to 11
   HUDStateSet->setRenderBinDetails( 99, "RenderBin");
   HUDStateSet2->setRenderBinDetails( 98, "RenderBin");
   HUDStateSet2->setRenderBinDetails( 97, "RenderBin");
   // set global geode pointers for use in Keyboard event calls
   MyGeode = HUDGeode;
   MyGeode2 = HUDGeode2;

   // Declare a box class (derived from shape class) instance
   // This constructor takes an osg::Vec3 to define the center
   //  and a float to define the height, width and depth.
   //  (an overloaded constructor allows you to specify unique
   //   height, width and height values.)
   osg::Box* unitCube = new osg::Box( osg::Vec3(0,0,0), 5.0f, 0.01f, 2.5f);
   unitCube->setDataVariance(osg::Object::DYNAMIC);

   // Declare an instance of the shape drawable class and initialize 
   //  it with the unitCube shape we created above.
   //  This class is derived from 'drawable' so instances of this
   //  class can be added to Geode instances.
   osg::ShapeDrawable* unitCubeDrawable = new osg::ShapeDrawable(unitCube);

   // Declare a instance of the geode class: 
   osg::Geode* basicShapesGeode = new osg::Geode();

   // Add the unit cube drawable to the geode:
   basicShapesGeode->addDrawable(unitCubeDrawable);

   // Add the goede to the scene:
   root->addChild(basicShapesGeode);
  

   //osg::Texture2D* KLN89FaceTexture = new osg::Texture2D;
   //osg::setNotifyLevel(osg::DEBUG_INFO);

   // protect from being optimized away as static state:
   KLN89FaceTexture->setDataVariance(osg::Object::DYNAMIC); 
   //osg::Image* klnFace = osgDB::readImageFile("KLN89FaceB.tga");
   osg::Image* klnFace = osgDB::readImageFile("mg.jpg");
   if (!klnFace)
   {
      std::cout << " couldn't load texture, quitting." << std::endl;
      //return -1;
   }

 //  osg::Vec2Array* bgtexcoords = new osg::Vec2Array(4);
 //  (*bgtexcoords)[0].set(0.0f,0.0f);
 //  (*bgtexcoords)[1].set(1.0f,0.0f);
 //  (*bgtexcoords)[2].set(1.0f,1.0f);
 //  (*bgtexcoords)[3].set(0.0f,1.0f);
 //  basicShapesGeode->setTexCoordArray(0,bgtexcoords);
    
   KLN89FaceTexture->setImage(klnFace);

   // Declare a state set for 'BLEND' texture mode
   osg::StateSet* blendStateSet = new osg::StateSet();

   // Declare a TexEnv instance, set the mode to 'BLEND'
   osg::TexEnv* blendTexEnv = new osg::TexEnv;
   blendTexEnv->setMode(osg::TexEnv::BLEND);
   

   // Turn the attribute of texture 0 'ON'
   blendStateSet->setTextureAttributeAndModes(0,KLN89FaceTexture,osg::StateAttribute::ON);
   // Set the texture texture environment for texture 0 to the 
   //  texture envirnoment we declared above:
   blendStateSet->setTextureAttribute(0,blendTexEnv);

   osg::StateSet* decalStateSet = new osg::StateSet();
   osg::TexEnv* decalTexEnv = new osg::TexEnv();
   decalTexEnv->setMode(osg::TexEnv::DECAL);

   decalStateSet->setTextureAttributeAndModes(0,KLN89FaceTexture,osg::StateAttribute::ON);
   decalStateSet->setTextureAttribute(0,decalTexEnv);

   //mg root->setStateSet(blendStateSet);
   basicShapesGeode->setStateSet(blendStateSet);
   

   Producer::CameraConfig* myCameraConfig = setupCameras();
   osgProducer::Viewer viewer(myCameraConfig);

 // Keyboard handlers
   keyboardEventHandler* keh_l = new keyboardEventHandler();
   keh_l->addFunction('l',LockOrUnlock);
   viewer.getEventHandlerList().push_front(keh_l); 

//  variables for getting local time
   time_t currentTime;
   tm localTime;
   time(&currentTime); // get current time_t value
   localTime=*(localtime(&currentTime)); // dereference and assign
   int timeUpdateCounter = 0;  // counter to determine when to update HUD clock


//ACE setup
   if (mcast_dgram_.subscribe (mcast_addr_) == -1){
		ACE_DEBUG((LM_DEBUG,"Error in subscribing to Multicast address \n"));
   }
//End of ACE setup

   //tankFollowerCamera->addPostDrawCallback( new CaptureImageCallback );

   viewer.setUpViewer(osgProducer::Viewer::STANDARD_SETTINGS);
   viewer.setSceneData( root );

   viewer.realize();

   while( !viewer.done() )
   {
      viewer.sync();
      viewer.update();

	  if (timeUpdateCounter%5 == 0) {  // only update every 50th frame so as not to kill framerate on graphics
	    time(&currentTime);                   // get current time_t value
		localTime=*(localtime(&currentTime)); // dereference and assign

		sprintf(tempstr,"%3d:%2d:%2d:%2d.%3d",localTime.tm_yday,localTime.tm_hour,localTime.tm_min,localTime.tm_sec,timeUpdateCounter%1000);
		textOne->setText(tempstr);
	  }

	  UpdateTSPI();

      viewer.frame();
   } 
   return ;
}
