/////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file RTTC/ForceFeedback/BasicImpl/SubscriberImpl.h
 * \version 5.2.1
 *
 * \brief Contains all the \#include files for subscribing to
 * RTTC::ForceFeedback SDOs.
 *
 * This header file aggregates numerous other header files needed by virtually
 * any TENA Middleware application that subscribes to
 * RTTC::ForceFeedback SDOs.
 *
 * It is the one header file that all TENA Middleware application programs
 * should \#include in order to subscribe to
 * RTTC::ForceFeedback SDOs.
 */

#ifndef RTTC_ForceFeedback_BasicImpl_SubscriberImpl_h
#define RTTC_ForceFeedback_BasicImpl_SubscriberImpl_h

#include <RTTC/ForceFeedback/Subscriber.h>
#include <basicImpl_RTTC_TASemulator_v4_mscRegisterFactory.h>
#include "CallbackInfo.h"
#include "DestructionCallbackFactoryImpl.h"
#include "DestructionCallbackImpl.h"
#include "DiscoveryCallbackFactoryImpl.h"
#include "DiscoveryCallbackImpl.h"
#include "StateChangeCallbackFactoryImpl.h"
#include "StateChangeCallbackImpl.h"
#include "SubscriptionInfoImpl.h"

#endif // ifndef RTTC_ForceFeedback_BasicImpl_SubscriberImpl_h
