/////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file RTTC/ForceFeedback/BasicImpl/SubscriptionInfoImpl.cpp
 * \version 5.2.1
 *
 * \brief Contains the definition of methods of
 * RTTC::ForceFeedback::BasicImpl::SubscriptionInfoImpl.
 *
 * This file contains the definition of the methods of the
 * RTTC::ForceFeedback::BasicImpl::SubscriptionInfoImpl class.
 */

#include "SubscriptionInfoImpl.h"
#include "CallbackInfo.h" // To give smart pointer complete type for deletion

#include "DestructionCallbackFactoryImpl.h"
#include <RTTC/ForceFeedback/NullDestructionCallbackFactory.h>
#include "DiscoveryCallbackFactoryImpl.h"
#include <RTTC/ForceFeedback/NullDiscoveryCallbackFactory.h>
#include "StateChangeCallbackFactoryImpl.h"
#include <RTTC/ForceFeedback/NullStateChangeCallbackFactory.h>


///////////////////////////////////////////////////////////////////////////////
RTTC::ForceFeedback::BasicImpl::
SubscriptionInfoImpl::
SubscriptionInfoImpl( CallbackInfoPtr const & pCallbackInfo )
:
  RTTC::ForceFeedback::SubscriptionInfo(
    DiscoveryCallbackFactoryPtr(
      new DiscoveryCallbackFactoryImpl( pCallbackInfo ) ),
    StateChangeCallbackFactoryPtr(
      new StateChangeCallbackFactoryImpl( pCallbackInfo ) ),
    DestructionCallbackFactoryPtr(
      new DestructionCallbackFactoryImpl( pCallbackInfo ) )   )
{
}

///////////////////////////////////////////////////////////////////////////////
RTTC::ForceFeedback::BasicImpl::
SubscriptionInfoImpl::
~SubscriptionInfoImpl()
{
}
