//////////////////////////////////////////////////////////////////// -*- C++ -*-
/*! \file RTTC/TASemulator/BasicImpl/DestructionCallbackFactoryImpl.cpp
 * \version 5.2.1
 *
 * \brief Contains the definition of methods of
 * RTTC::TASemulator::BasicImpl::DestructionCallbackFactoryImpl.
 *
 * This file contains the definition of the methods of the
 * RTTC::TASemulator::BasicImpl::DestructionCallbackFactoryImpl class.
 */

#include "DestructionCallbackFactoryImpl.h"

////////////////////////////////////////////////////////////////////////////////
RTTC::TASemulator::BasicImpl::
DestructionCallbackFactoryImpl::
~DestructionCallbackFactoryImpl()
{
  // Basic implementation has no behavior required in callback destructor
}

////////////////////////////////////////////////////////////////////////////////
RTTC::TASemulator::BasicImpl::
DestructionCallbackFactoryImpl::
DestructionCallbackFactoryImpl( CallbackInfoPtr const & pCallbackInfo )
  :
  _pCallbackInfo( pCallbackInfo )
{
  // Generally no behavior in a factory constructor
}

////////////////////////////////////////////////////////////////////////////////
std::auto_ptr< TENA::Middleware::Callback::Callback >
RTTC::TASemulator::BasicImpl::
DestructionCallbackFactoryImpl::
create( RTTC::TASemulator::ProxyPtr const & pProxy )
{
  // For the basic implementation, all the callbacks access a list
  // of SDO, which is kept updated as SDO's are discovered and destroyed

  return std::auto_ptr< TENA::Middleware::Callback::Callback >(
    new RTTC::TASemulator::BasicImpl::DestructionCallbackImpl(
      pProxy,
      _pCallbackInfo ) );
}
