// TASEmulatorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TASEmulator.h"
#include "TASEmulatorDlg.h"
#include ".\tasemulatordlg.h"

#define TENA_PLATFORM xp-vc80-d


#include <TENA/Middleware/Config.h>
//#include <TASEmulatorPublisherSingleton.h>
#include <ace/os.h>
#include "ace/ace.h"

#include "aceosgthread.h"
#include "TENASubscriber.h"
#include "TENAPublisher.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

extern double gMFCfieldOfView;
int globalOSGPanValue;
int globalOSGTiltValue;

double gMFCpsi;
double gMFCtheta;
double gMFCphi;

extern double xPosition;
extern double yPosition;
extern double zPosition;

extern double psi;
extern double theta;
extern double phi;

bool bResignTENA = false;
bool bResignOSG  = false;

// GUI Status Bar indicators
static UINT BASED_CODE indicators[] =
{
	IDC_INDICATOR_POS,
	IDC_INDICATOR_TIME
};


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTASEmulatorDlg dialog



CTASEmulatorDlg::CTASEmulatorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTASEmulatorDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTASEmulatorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER_PAN, m_SliderPan);
	DDX_Control(pDX, IDC_SLIDER_TILT, m_SliderTilt);
}

BEGIN_MESSAGE_MAP(CTASEmulatorDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTONSTARTTAS, OnBnClickedButtonstarttas)
	ON_BN_CLICKED(IDC_BUTTONJOINTENA, OnBnClickedButtonjointena)
	ON_BN_CLICKED(IDC_BUTTONRESIGNTENA, OnBnClickedButtonresigntena)
	ON_BN_CLICKED(IDOK, &CTASEmulatorDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CTASEmulatorDlg message handlers

BOOL CTASEmulatorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_SliderPan.SetKnobPosi(0,0);

	m_SliderTilt.SetRange(-60, 60);
	m_SliderTilt.SetPos(-20);  // Set to -20 - as in OSG module slider value is divided by 20 
	                          // to fine tune increments (20/20 = 1 --> default)
	
	//m_SliderTilt.SetSelection(-20, 20);

	m_SliderTilt.SetTicFreq(5);
	m_SliderTilt.SetThumbColor(RGB(255, 0, 0));
	m_SliderTilt.SetSelectionColor(RGB(255, 64, 64));
	m_SliderTilt.SetChannelColor(RGB(255, 196, 196));

	// Status bar initialization
	m_bar.Create(this);
	m_bar.SetIndicators(indicators,2);
	CRect rect;
	GetClientRect(&rect);
	m_bar.SetPaneInfo(0,IDC_INDICATOR_POS,SBPS_NORMAL,rect.Width()-200);
	m_bar.SetPaneInfo(1,IDC_INDICATOR_TIME,SBPS_STRETCH,0);
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, IDC_INDICATOR_TIME);
	m_bar.GetStatusBarCtrl().SetBkColor(RGB(180,180,100));

	// this is the timer so that events can get recognized in the MFC gui world
	_nTimer = SetTimer(1, 100, NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTASEmulatorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTASEmulatorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTASEmulatorDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTASEmulatorDlg::OnBnClickedButtonstarttas()
{
	thread_data myArgs;
   
	ACE_Thread_Manager *tm = ACE_Thread_Manager::instance();
	
	tm->spawn(ACE_THR_FUNC(StartOSGThread), (void *) &myArgs);
	
	ACE_OS::sleep(ACE_Time_Value(5,0));
}

void CTASEmulatorDlg::OnBnClickedButtonjointena()
{
	CString sTENAInfo;

	// spawn TENA publsher thread
    thread_data myArgsSub, myArgsPub;
  
	ACE_Thread_Manager *tmSub = ACE_Thread_Manager::instance();
	
	tmSub->spawn(ACE_THR_FUNC(TENASubscriber), (void *) &myArgsSub);
	ACE_OS::sleep(ACE_Time_Value(1,0));

	//ACE_Thread_Manager *tmPub = ACE_Thread_Manager::instance();
	
	//tmPub->spawn(ACE_THR_FUNC(TENAPublisher), (void *) &myArgsPub);

	UpdateData();
	m_bar.SetPaneText(0,sTENAInfo);
	//m_bar.SetPaneText(1,sTriple_Ori);
	UpdateData(false);
}

void CTASEmulatorDlg::OnBnClickedButtonresigntena()
{
	CString sTENAInfo;

	bResignTENA = true;

/*	if(TAS_EMULATOR_PUBLISHER->ResignTENA()){
			//GetDlgItem(IDC_INFO)->SetWindowText("Resigned TENA");
			sTENAInfo.Format("Resigned TENA");
			UpdateData();
			m_bar.SetPaneText(0,sTENAInfo);
			//m_bar.SetPaneText(1,sTriple_Ori);
			UpdateData(false);
	}*/
}


//Inputs:   none
//Outputs:  None
//Return Values:  None
//Developers Name:  Mike Greene
//Date Started:  08/09/05
//Maintenance Record:
void CTASEmulatorDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if (pScrollBar == NULL){
		return;
	}
    CString str = _T("");
	if (pScrollBar->m_hWnd == m_SliderTilt.m_hWnd)
	{

		int m_nRed = m_SliderTilt.GetPos();
		str.Format("%3d Deg", m_nRed);  // Note - sign changed here on Display because it looks better if positive values are up
		globalOSGTiltValue = m_nRed; // set global value to pass to OSG for tilting view
		GetDlgItem(IDC_STATIC_TILTTEXT)->SetWindowText(str);  // set text box to show slider value

		UpdateData(FALSE);
		CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
	
	}
}

void CTASEmulatorDlg::OnTimer(UINT nIDEvent)
{

	CString str = _T("");

	str.Format("UUT Pos %f8.2,%f8.2,%f8.2",xPosition,yPosition,zPosition);
	m_bar.SetPaneText(0,str);
	str.Format("Eulers %f8.2,%f8.2,%f8.2",gMFCpsi,gMFCtheta,gMFCphi);
	m_bar.SetPaneText(1,str);

	UpdateData(FALSE);

	CDialog::OnTimer(nIDEvent);
}
void CTASEmulatorDlg::OnBnClickedOk()
{
	bResignTENA = true;
	bResignOSG  = true;
	Sleep(2000);

	OnOK();
}
