/////////////////////////////////////////////////////////////////// -*- C++ -*-
/*!
 * \file basicImpl_RTTC_TASemulator_v4_mscRegisterFactory.h
 * \version 5.2.1
 *
 * \brief Force the Microsoft C++ linker to link in the implementation library.
 *
 * Because registration of local class and message methods factories happens
 * during static initialization of the implementation library, it is possible
 * that an application that needs to have these factories registered may never
 * actually refer to a symbol in the library.  The Microsoft C++ linker will
 * ordinarily not link in the implementation library in that case.  Including
 * this header ensures that a symbol in the library is in fact used, and
 * accordingly the library will be linked in.
 */

#ifndef basicImpl_RTTC_TASemulator_v4_mscRegisterFactory_h
#define basicImpl_RTTC_TASemulator_v4_mscRegisterFactory_h

#include <fullConversion_v3_TENA_Time_v1_1_mscRegisterFactory.h>
#include <positionConversion_v4_TENA_TSPI_v4_mscRegisterFactory.h>
#include <noConversion_v3_TENA_Acceleration_v1_mscRegisterFactory.h>
#include <utils_v3_TENA_SRF_v1_mscRegisterFactory.h>
#include <noConversion_v3_TENA_Orientation_v1_mscRegisterFactory.h>
#include <fullConversion_v3_TENA_Position_v1_mscRegisterFactory.h>
#include <noConversion_v3_TENA_Velocity_v1_mscRegisterFactory.h>
#include <userDefined_v1_TENA_UniqueID_v2_mscRegisterFactory.h>
#include <csvReader_v2_TENA_PlatformType_v1_mscRegisterFactory.h>
#include <basicImpl_RTTC_TASemulator_v4_EXPORT.h>

//
// This is needed for the Microsoft Visual C++ linker to consistently pull in
// this library's symbols when it should.
//
extern basicImpl_RTTC_TASemulator_v4_EXPORT int basicImpl_RTTC_TASemulator_v4_forceThisLibraryToBeLinked;

namespace
{
  int usebasicImpl_RTTC_TASemulator_v4_forceThisLibraryToBeLinked =
    basicImpl_RTTC_TASemulator_v4_forceThisLibraryToBeLinked;
}

#endif // ifndef basicImpl_RTTC_TASemulator_v4_mscRegisterFactory_h
