//  Target Organization:  RTTC Dynamic Test Branch (TA-2)
//  Develpment Organization : Trideum Corporation
//  Developer : Mike Greene   mgreene@trideum.com
//  Developer's Phone :  (256) 704-6113
//  OpenSceneGraph Version 1.1  (www.openscenegraph.org)
//
//  Last Mod 10-26-2006
//
#include "stdafx.h"

#define TENA_PLATFORM xp-vc80-d

#include <TENA/Middleware/config.h>
#include <TENA/Platform/BasicImpl/SubscriberImpl.h>

// *implementation* needed to create and access the local class
#include <TENA/UniqueID/Includes.h>
#include <TENA/Time/Includes.h>
#include <TENA/CoordinatedUniversalTime/Includes.h>
#include <TENA/Date/Includes.h>
#include <TENA/GpsTime/Includes.h>
#include <TENA/UnixTime/Includes.h>
#include <TENA/PlatformType/Includes.h>
#include <DIS/EntityType/Includes.h>
#include <TENA/TSPI/Includes.h>
#include <TENA/AngularAcceleration/Includes.h>
#include <TENA/AngularVelocity/Includes.h>
#include <TENA/GeocentricAcceleration/Includes.h>
#include <TENA/GeocentricSpatialReferenceFrame/Includes.h>
#include <TENA/SpatialReferenceFrame/Includes.h>
#include <TENA/GeocentricOrientationEuler/Includes.h>
#include <TENA/GeocentricPosition/Includes.h>
#include <TENA/GeocentricVelocity/Includes.h>
#include <TENA/GeodeticAcceleration/Includes.h>
#include <TENA/GeodeticSpatialReferenceFrame/Includes.h>
#include <TENA/GeodeticOrientationEuler/Includes.h>
#include <TENA/GeodeticPosition/Includes.h>
#include <TENA/GeodeticVelocity/Includes.h>
#include <TENA/LocalSphericalTangentPlaneAcceleration/Includes.h>
#include <TENA/LocalSphericalTangentPlaneSpatialReferenceFrame/Includes.h>
#include <TENA/LocalSphericalTangentPlaneOrientationEuler/Includes.h>
#include <TENA/LocalSphericalTangentPlanePosition/Includes.h>
#include <TENA/LocalSphericalTangentPlaneVelocity/Includes.h>
#include <TENA/LocalTangentPlaneENUacceleration/Includes.h>
#include <TENA/LocalTangentPlaneENUspatialReferenceFrame/Includes.h>
#include <TENA/LocalTangentPlaneENUorientationEuler/Includes.h>
#include <TENA/LocalTangentPlaneENUposition/Includes.h>
#include <TENA/LocalTangentPlaneENUvelocity/Includes.h>
#include <TENA/Acceleration/Includes.h>
#include <TENA/Orientation/Includes.h>
#include <TENA/Position/Includes.h>
#include <TENA/Velocity/Includes.h>
// OSG includes
#include <osg/Node>
#include <osg/Group>
#include <osg/Geode>
#include <osg/Notify>
#include <osg/Geometry>
#include <osg/Texture2D>
#include <osgDB/ReadFile>
#include <osgDB/FileUtils>

#include <osg/PositionAttitudeTransform>

#include <osgText/Font>
#include <osgText/Text>
#include <osg/MatrixTransform>

#include <osg/Projection>
#include <osg/ShapeDrawable>

#include <osgDB/WriteFile>

#include <osg/StateSet>
#include <osg/Texture2D>
#include <osg/TexEnv>
#include <osg/TexGen>
#include <osg/ShapeDrawable>

#include <osgViewer/Viewer>
#include <osgViewer/ViewerEventHandlers>
#include <osgViewer/CompositeViewer>
#include <osgGA/TrackballManipulator>

#include "KeyboardHandler.h"
#include "orientation.h"

//  Global variables used to pass data to OSG Thread
extern int XPlane_Unique_ID;
extern int XPlane_Unique_ModelID;

extern double xPosition;
extern double yPosition;
extern double zPosition;

extern double psi;
extern double theta;
extern double phi;

extern double xVelocity;
extern double yVelocity;
extern double zVelocity;

extern long timeStamp;

#include "xmlParser.h"
void ReadInXMLInfo();
//XML input terrain and vehicle model info
std::string sXMLTerrainFileName;
std::string sXMLTerrainPathName;

std::string sXMLVehicleFileName;
std::string sXMLVehiclePathName;

std::string sXMLMulticastAddress;
std::string sXMLRamdisk;
std::string sXMLSymbolsIBAS;
std::string sXMLReticule;


osgDB::FilePathList pathList;
double xOffsetToZero, yOffsetToZero, zOffsetToZero; // read in from XML file to position (0,0,0) on terrain

char tempstr[] = "                                        ";

// ACE defines
#define MYBUFSIZE 32768
//#define DEFAULT_MULTICAST_ADDR "224.9.9.2"

/* 
   Use the typical TCP/IP port address for receiving datagrams. 
 */ 
static const u_short PORT = ACE_DEFAULT_SERVER_PORT; 
/* 
       This is where we'll listen for datagrams coming from the 
       clients.  We'll give this address to the open() method 
       below to enable the listener. 
     */ 

ssize_t recv_count;

long data_counter = 0;

double gMFCfieldOfView;  // used for temp debugging - passed to MFC module
extern int globalOSGPanValue; //this is the value from the Pan slider
extern int globalOSGTiltValue; //this is the value from the Tilt slider

#define TIMEOUT 5
// no longer used in this module but left for doc purposes
// these are the necessary offsets to put the UUT at the disred terrain location
// where Bill Barber's data was run - no longer used in this app
//#define XOFFSET_MOUT0 760.0
//#define YOFFSET_MOUT0 1570.0
//#define ZOFFSET_MOUT0 187.50

// CxImage includes
#include "ximage.h"
#include "ximagif.h"
#include "ximatif.h"
#include "xfile.h"

CxImage  myimage;

// global OSG constructs
osg::Texture2D* sceneTexture = new osg::Texture2D();
osg::Texture2D* KLN89FaceTexture = new osg::Texture2D;

//loop counters for debug messaging
int firsttime = 0;
long icount = 0;
// global for turning lock symbology on and off
bool bLockOn = false;

// Matrix transform node for positioning HUD:
osg::PositionAttitudeTransform* HUDXform;
osg::PositionAttitudeTransform* HUDXform2;
osg::PositionAttitudeTransform* HUDXform3;
// Position of HUD(s):
osg::Vec3 HUDPosit;
osg::Vec3 HUDPosit2;
osg::Vec3 HUDPosit3;
osg::Geode* MyGeode = new osg::Geode();      // copy of HUD geode for crosshairs
osg::Geode* MyGeode2 = new osg::Geode();     // copy of HUD geode for reticules
osg::Geode* MyGeode3 = new osg::Geode();     // copy of HUD geode for static symbology

osgViewer::View* view1  = new osgViewer::View();


osgViewer::CompositeViewer viewer;
osgGA::TrackballManipulator *Tman1 = new osgGA::TrackballManipulator();
osg::ref_ptr<osg::Camera> mainCamera = new osg::Camera;

extern osgViewer::View*  createViewNew (osgViewer::CompositeViewer *viewer,
                 osg::ref_ptr<osg::Group> scene,
                 osg::ref_ptr<osg::GraphicsContext> gc,
                 osgGA::TrackballManipulator* Tman,
                 int x, int y, int width, int height);


extern bool bResignOSG;

//callback class
// via ACE multicast, reads a compressed jpeg image send from the Scene generator
// takes this image and pastes it as a texture to a 2D plane that is what is viewed
//  as the TAS view
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 04/08/2009
//

struct SnapImage : public osg::Camera::DrawCallback
{
    SnapImage()
    {
        _image = new osg::Image;        
    }

    virtual void operator () (osg::RenderInfo& renderInfo) const
    {

	  // ACE multicast setup
			ACE_INET_Addr  local(PORT); 
			ACE_SOCK_Dgram_Mcast mcast_dgram_;
			ACE_INET_Addr remote((u_short)0);
			ACE_INET_Addr mcast_addr_(2000,sXMLMulticastAddress.c_str());

			ACE_Time_Value timeOut(1,0);

			if (mcast_dgram_.subscribe (mcast_addr_) == -1){
				MessageBox(NULL,"Error in subscribing to Multicast address ","",MB_OK);
			}
            
				BYTE bytebuf[MYBUFSIZE];
			
				// receive datagram - wait for timeOut seconds until continuing
				recv_count = mcast_dgram_.recv(&bytebuf,sizeof(bytebuf),local,0,&timeOut);
				

				icount++;
				std::string sRamFile;
				sRamFile = sXMLRamdisk + std::string("\\image1.jpg");

				// via CXimage lib, convert bytes back to jpeg image in RAMDisk
				CxImage mimage(bytebuf,recv_count,CXIMAGE_FORMAT_JPG);
				mimage.Save(sRamFile.c_str(),CXIMAGE_FORMAT_JPG);

				// OSG reads image from RAMDisk and pastes texture onto plane
				osg::Image* klnFace  = osgDB::readImageFile(sRamFile);
			
				if (recv_count > 0) KLN89FaceTexture->setImage(klnFace);
				mimage.Destroy();
				
			    mcast_dgram_.close();
			}

    mutable osg::ref_ptr<osg::Image>    _image;
};

// create OSG quad plane at specified position
//  This will be the plane that the recieved jpeg texture will be pasted into
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 10/08/2006
osg::Drawable* createSquare(const osg::Vec3& corner,const osg::Vec3& width,const osg::Vec3& height, osg::Image* image=NULL)
{
    // set up the Geometry.
    osg::Geometry* geom = new osg::Geometry;

	// calculate plane's corners
    osg::Vec3Array* coords = new osg::Vec3Array(4);
    (*coords)[0] = corner;
    (*coords)[1] = corner+width;
    (*coords)[2] = corner+width+height;
    (*coords)[3] = corner+height;

    geom->setVertexArray(coords);
    // calculate normals
    osg::Vec3Array* norms = new osg::Vec3Array(1);
    (*norms)[0] = width^height;
    (*norms)[0].normalize();
    
    geom->setNormalArray(norms);
    geom->setNormalBinding(osg::Geometry::BIND_OVERALL);
    // calculate texture coordinates
    osg::Vec2Array* tcoords = new osg::Vec2Array(4);
    (*tcoords)[0].set(0.0f,0.0f);
    (*tcoords)[1].set(1.0f,0.0f);
    (*tcoords)[2].set(1.0f,1.0f);
    (*tcoords)[3].set(0.0f,1.0f);
    geom->setTexCoordArray(0,tcoords);
    
    geom->addPrimitiveSet(new osg::DrawArrays(osg::PrimitiveSet::QUADS,0,4));
    // if texture is read in correctly, paste it as a texture onto plane
    if (image)
    {
        osg::StateSet* stateset = new osg::StateSet;
        osg::Texture2D* texture = new osg::Texture2D;
        texture->setImage(image);
        stateset->setTextureAttributeAndModes(0,texture,osg::StateAttribute::ON);
        geom->setStateSet(stateset);
    }
    
    return geom;
}
// Routine to toggle Cross hairs and other symbology On/Off
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 10/08/2006
void LockOrUnlock(void)
{
   // check currect status of lock varibale and turn lock symbology on or off depending
   //  on current state
	if (bLockOn) {
		bLockOn = false;
		MyGeode->setNodeMask(0); 
	}
	else {
		bLockOn = true;
		MyGeode->setNodeMask(~0); 
	}
}
// Routine to get TENA TSPI (jittered values)
//  Then publish out needed values that will be subscribed to by Scene Generator
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 10/08/2006
void UpdateTSPI(void)
{
	// get current tspi from joystick app (includes jitter, etc.)
/*	platform = TAS_EMULATOR_PUBLISHER->GetPlatform();

	// convert to three Eulers to be able to pass thru TENA
	double psi, theta, phi;
	Orientation::Quaternian_to_Euler(platform.quatW, platform.quatX, platform.quatY, platform.quatZ, psi, theta, phi);
			

	// set values to be published out to scene generator
	TAS_.fieldOfView = 90; //not used - simply for debugging here
	gMFCfieldOfView = TAS_.fieldOfView;
	TAS_.terrainID = 101;
	TAS_.viewFromX = platform.posX;
	TAS_.viewFromY = platform.posY;
	TAS_.viewFromZ = platform.posZ;
// because of omissions in OM, these three vars are used to pass orientation in Euler angles
	TAS_.viewRotationAngle = psi-(osg::DegreesToRadians((double)globalOSGPanValue)); //was + per KK 10-23-06
	TAS_.viewToX = theta;
	TAS_.viewToY = phi+(osg::DegreesToRadians((double)globalOSGTiltValue));

	TAS_.zoomFactor = 1.0;  //not used in this version

	TAS_EMULATOR_PUBLISHER->UpdateTAS(TAS_); //publish out new TAS values
	sceneGenerator = TAS_EMULATOR_PUBLISHER->GetSceneGenerator();  */
}

void UpdateTSPI07(void)
{
	// get current tspi from joystick app (includes jitter, etc.)
/*	platform = TAS_EMULATOR_PUBLISHER->GetPlatform();

	// convert to three Eulers to be able to pass thru TENA
	double psi, theta, phi;
	Orientation::Quaternian_to_Euler(platform.quatW, platform.quatX, platform.quatY, platform.quatZ, psi, theta, phi);
			

	// set values to be published out to scene generator
	TAS_.fieldOfView = 90; //not used - simply for debugging here
	gMFCfieldOfView = TAS_.fieldOfView;
	TAS_.terrainID = 101;
	TAS_.viewFromX = platform.posX;
	TAS_.viewFromY = platform.posY;
	TAS_.viewFromZ = platform.posZ;
// because of omissions in OM, these three vars are used to pass orientation in Euler angles
	TAS_.viewRotationAngle = psi-(osg::DegreesToRadians((double)globalOSGPanValue)); //was + per KK 10-23-06
	TAS_.viewToX = theta;
	TAS_.viewToY = phi+(osg::DegreesToRadians((double)globalOSGTiltValue));

	TAS_.zoomFactor = 1.0;  //not used in this version

	TAS_EMULATOR_PUBLISHER->UpdateTAS(TAS_); //publish out new TAS values
	sceneGenerator = TAS_EMULATOR_PUBLISHER->GetSceneGenerator();*/
}


// Main OSG loop function
// Developer : Mike Greene, Trideum Corp.
// Date Implemented : 10/08/2006
void OSG_Module(void)
{
   // Text instance for HUD:
   osgText::Text* textOne = new osgText::Text();  // IRIG time display
   // Declare a group to act as root node of a scene:
   osg::Group* root = new osg::Group();

// read in path and model initialization from xml file
   pathList = osgDB::getDataFilePathList();
   ReadInXMLInfo();
   //MessageBox(NULL,"After XML read","",MB_OK);
  
   osgDB::setDataFilePathList(pathList);

   // add the drawable into a single goede to be shared...
    osg::Billboard* center = new osg::Billboard();
    center->setMode(osg::Billboard::POINT_ROT_EYE);
    center->addDrawable(
        createSquare(osg::Vec3(-0.5f,0.0f,-0.5f),osg::Vec3(2.0f,0.0f,0.0f),osg::Vec3(0.0f,0.0f,1.0f),osgDB::readImageFile("b:\\image2.jpg")),
        osg::Vec3(0.0f,0.0f,0.0f));

    // A geometry node for our HUD(s):
   osg::Geode* HUDGeode = new osg::Geode();
   osg::Geode* HUDGeode2 = new osg::Geode();
   osg::Geode* HUDGeode3 = new osg::Geode();
   // Projection nodes for defining view frustrum for HUD(s):
   osg::Projection* HUDProjectionMatrix = new osg::Projection;
   osg::Projection* HUDProjectionMatrix2 = new osg::Projection;
   osg::Projection* HUDProjectionMatrix3 = new osg::Projection;
   // Initialize the projection matrix for viewing everything we
   // will add as descendents of this node. Use screen coordinates
   // to define the horizontal and vertical extent of the projection
   // matrix. Positions described under this node will equate to
   // pixel coordinates.
   HUDProjectionMatrix->setMatrix(osg::Matrix::ortho2D(0,512,0,512));
   HUDProjectionMatrix2->setMatrix(osg::Matrix::ortho2D(0,512,0,512));
   HUDProjectionMatrix3->setMatrix(osg::Matrix::ortho2D(0,512,0,512));
   // For the HUD model view matrix use an identity matrix:
   osg::MatrixTransform* HUDModelViewMatrix = new osg::MatrixTransform;
   HUDModelViewMatrix->setMatrix(osg::Matrix::identity());
   osg::MatrixTransform* HUDModelViewMatrix2 = new osg::MatrixTransform;
   HUDModelViewMatrix2->setMatrix(osg::Matrix::identity());
   osg::MatrixTransform* HUDModelViewMatrix3 = new osg::MatrixTransform;
   HUDModelViewMatrix3->setMatrix(osg::Matrix::identity());
   // Make sure the model view matrix is not affected by any transforms
   // above it in the scene graph:
   HUDModelViewMatrix->setReferenceFrame(osg::Transform::ABSOLUTE_RF);
   HUDModelViewMatrix2->setReferenceFrame(osg::Transform::ABSOLUTE_RF);
   HUDModelViewMatrix3->setReferenceFrame(osg::Transform::ABSOLUTE_RF);
    // Add the HUD projection matrix as a child of the root node
   // and the HUD model view matrix as a child of the projection matrix
   // Anything under this node will be view using this projection matrix
   // and positioned with this model view matrix.
   root->addChild(HUDProjectionMatrix);
   root->addChild(HUDProjectionMatrix2);
   root->addChild(HUDProjectionMatrix3);
   HUDProjectionMatrix->addChild(HUDModelViewMatrix);
   HUDProjectionMatrix->addChild(HUDModelViewMatrix2);
   HUDProjectionMatrix->addChild(HUDModelViewMatrix3);
   // Add the Geometry node to contain HUD geometry as a child of the
   // HUD model view matrix.
   // (See figure "n")
   HUDXform = new osg::PositionAttitudeTransform();
   HUDPosit.set(0,1.5,1.0);
   HUDXform->setPosition( HUDPosit );
   HUDModelViewMatrix->addChild( HUDXform );
   HUDXform->addChild( HUDGeode );

   HUDXform2 = new osg::PositionAttitudeTransform();
   HUDPosit2.set(0,1.5,1.0);
   HUDXform2->setPosition( HUDPosit2 );
   HUDModelViewMatrix2->addChild( HUDXform2 );
   HUDXform2->addChild( HUDGeode2 );

   HUDXform3 = new osg::PositionAttitudeTransform();
   HUDPosit3.set(0,1.5,1.0);
   HUDXform3->setPosition( HUDPosit3 );
   HUDModelViewMatrix2->addChild( HUDXform3 );
   HUDXform3->addChild( HUDGeode3 );

   // Add the text (Text class is derived from drawable) to the geode:
   HUDGeode->addDrawable( textOne );
   // Set up the parameters for the text we'll add to the HUD:
   textOne->setCharacterSize(15);
   textOne->setFont("Arcade_Interlaced.ttf"); 
   textOne->setText("180:12:43:56.189");
   textOne->setAxisAlignment(osgText::Text::SCREEN);
   textOne->setPosition( osg::Vec3(50,450,-1.5) );
   textOne->setColor( osg::Vec4(199,199, 15, 1) );
   // Set up geometry for the HUD and add it to the HUD
   // geometry node, see tutorial "n" for details:
   //
   // Note : we will use 3 separate HUD geodes so that they can be individually made
   //  invisible or visible for lock, etc.
   //
    osg::Geometry* HUDBackgroundGeometry = new osg::Geometry();
    osg::Vec3Array* HUDBackgroundVertices = new osg::Vec3Array;

	osg::Geometry* HUDBackgroundGeometry2 = new osg::Geometry();
    osg::Vec3Array* HUDBackgroundVertices2 = new osg::Vec3Array;

	osg::Geometry* HUDBackgroundGeometry3 = new osg::Geometry();
    osg::Vec3Array* HUDBackgroundVertices3 = new osg::Vec3Array;

   HUDBackgroundVertices->push_back( osg::Vec3( 0, 0,-1) );
   HUDBackgroundVertices->push_back( osg::Vec3(512, 0,-1) );
   HUDBackgroundVertices->push_back( osg::Vec3(512,512,-1) );
   HUDBackgroundVertices->push_back( osg::Vec3( 0,512,-1) );
   osg::DrawElementsUInt* HUDBackgroundIndices =
      new osg::DrawElementsUInt(osg::PrimitiveSet::POLYGON, 0);
   HUDBackgroundIndices->push_back(0);
   HUDBackgroundIndices->push_back(1);
   HUDBackgroundIndices->push_back(2);
   HUDBackgroundIndices->push_back(3);
   osg::Vec4Array* HUDcolors = new osg::Vec4Array;
   HUDcolors->push_back(osg::Vec4(0.8f,0.8f,0.8f,0.8f));

   HUDBackgroundVertices2->push_back( osg::Vec3( 0, 0,-1) );
   HUDBackgroundVertices2->push_back( osg::Vec3(512, 0,-1) );
   HUDBackgroundVertices2->push_back( osg::Vec3(512,512,-1) );
   HUDBackgroundVertices2->push_back( osg::Vec3( 0,512,-1) );
   osg::DrawElementsUInt* HUDBackgroundIndices2 =
      new osg::DrawElementsUInt(osg::PrimitiveSet::POLYGON, 0);
   HUDBackgroundIndices2->push_back(0);
   HUDBackgroundIndices2->push_back(1);
   HUDBackgroundIndices2->push_back(2);
   HUDBackgroundIndices2->push_back(3);
   osg::Vec4Array* HUDcolors2 = new osg::Vec4Array;
   HUDcolors2->push_back(osg::Vec4(0.8f,0.8f,0.8f,0.8f));

   HUDBackgroundVertices3->push_back( osg::Vec3( 0, 0,-1) );
   HUDBackgroundVertices3->push_back( osg::Vec3(512, 0,-1) );
   HUDBackgroundVertices3->push_back( osg::Vec3(512,512,-1) );
   HUDBackgroundVertices3->push_back( osg::Vec3( 0,512,-1) );
   osg::DrawElementsUInt* HUDBackgroundIndices3 =
      new osg::DrawElementsUInt(osg::PrimitiveSet::POLYGON, 0);
   HUDBackgroundIndices3->push_back(0);
   HUDBackgroundIndices3->push_back(1);
   HUDBackgroundIndices3->push_back(2);
   HUDBackgroundIndices3->push_back(3);
   osg::Vec4Array* HUDcolors3 = new osg::Vec4Array;
   HUDcolors3->push_back(osg::Vec4(0.8f,0.8f,0.8f,0.1f));

   osg::Vec2Array* texcoords = new osg::Vec2Array(4);
   (*texcoords)[0].set(0.0f,0.0f);
   (*texcoords)[1].set(1.0f,0.0f);
   (*texcoords)[2].set(1.0f,1.0f);
   (*texcoords)[3].set(0.0f,1.0f);

   HUDBackgroundGeometry->setTexCoordArray(0,texcoords);
   osg::Texture2D* HUDTexture = new osg::Texture2D;
   HUDTexture->setDataVariance(osg::Object::DYNAMIC);
   osg::Image* hudImage;

   HUDBackgroundGeometry2->setTexCoordArray(0,texcoords);
   osg::Texture2D* HUDTexture2 = new osg::Texture2D;
   HUDTexture2->setDataVariance(osg::Object::DYNAMIC);
   osg::Image* hudImage2;

   HUDBackgroundGeometry3->setTexCoordArray(0,texcoords);
   osg::Texture2D* HUDTexture3 = new osg::Texture2D;
   HUDTexture3->setDataVariance(osg::Object::DYNAMIC);
   osg::Image* hudImage3;
   // "locked" crosshair image put in this HUD Geode
   hudImage = osgDB::readImageFile(sXMLSymbolsIBAS);//"ibas_static2.png");
   HUDTexture->setImage(hudImage);
   osg::Vec3Array* HUDnormals = new osg::Vec3Array;
   HUDnormals->push_back(osg::Vec3(0.0f,0.0f,1.0f));
   HUDBackgroundGeometry->setNormalArray(HUDnormals);
   HUDBackgroundGeometry->setNormalBinding(osg::Geometry::BIND_OVERALL);
   HUDBackgroundGeometry->addPrimitiveSet(HUDBackgroundIndices);
   HUDBackgroundGeometry->setVertexArray(HUDBackgroundVertices);
   HUDBackgroundGeometry->setColorArray(HUDcolors);
   HUDBackgroundGeometry->setColorBinding(osg::Geometry::BIND_OVERALL);
   HUDGeode->addDrawable(HUDBackgroundGeometry);
   //  reticule - track gates - put in this HUD Geode
   hudImage2 = osgDB::readImageFile(sXMLReticule);//"reticule2.png");
   HUDTexture2->setImage(hudImage2);
   osg::Vec3Array* HUDnormals2 = new osg::Vec3Array;
   HUDnormals2->push_back(osg::Vec3(0.0f,0.0f,1.0f));
   HUDBackgroundGeometry2->setNormalArray(HUDnormals2);
   HUDBackgroundGeometry2->setNormalBinding(osg::Geometry::BIND_OVERALL);
   HUDBackgroundGeometry2->addPrimitiveSet(HUDBackgroundIndices2);
   HUDBackgroundGeometry2->setVertexArray(HUDBackgroundVertices2);
   HUDBackgroundGeometry2->setColorArray(HUDcolors2);
   HUDBackgroundGeometry2->setColorBinding(osg::Geometry::BIND_OVERALL);
   HUDGeode2->addDrawable(HUDBackgroundGeometry2);
   // dummy image put in the HUD Geode - this causes a transparent, colored overlay
   //  that gives the HUD an "IR" look
   hudImage3 = osgDB::readImageFile("dummy.png");
   HUDTexture3->setImage(hudImage3);
   osg::Vec3Array* HUDnormals3 = new osg::Vec3Array;
   HUDnormals3->push_back(osg::Vec3(0.0f,0.0f,1.0f));
   HUDBackgroundGeometry3->setNormalArray(HUDnormals3);
   HUDBackgroundGeometry3->setNormalBinding(osg::Geometry::BIND_OVERALL);
   HUDBackgroundGeometry3->addPrimitiveSet(HUDBackgroundIndices3);
   HUDBackgroundGeometry3->setVertexArray(HUDBackgroundVertices3);
   HUDBackgroundGeometry3->setColorArray(HUDcolors3);
   HUDBackgroundGeometry3->setColorBinding(osg::Geometry::BIND_OVERALL);
   HUDGeode3->addDrawable(HUDBackgroundGeometry3);

   osg::StateSet* HUDStateSet = new osg::StateSet();
   HUDGeode->setStateSet(HUDStateSet);
   HUDStateSet->
      setTextureAttributeAndModes(0,HUDTexture,osg::StateAttribute::ON);

   osg::StateSet* HUDStateSet2 = new osg::StateSet();
   HUDGeode2->setStateSet(HUDStateSet2);
   HUDStateSet2->
      setTextureAttributeAndModes(0,HUDTexture2,osg::StateAttribute::ON);

   osg::StateSet* HUDStateSet3 = new osg::StateSet();
   HUDGeode3->setStateSet(HUDStateSet3);
   HUDStateSet3->
      setTextureAttributeAndModes(0,HUDTexture3,osg::StateAttribute::ON);

   // For this state set, turn blending on (so alpha texture looks right)
   HUDStateSet->setMode(GL_BLEND,osg::StateAttribute::ON);
   HUDStateSet2->setMode(GL_BLEND,osg::StateAttribute::ON);
   HUDStateSet3->setMode(GL_BLEND,osg::StateAttribute::ON);

   // Disable depth testing so geometry is draw regardless of depth values
   // of geometry already draw.
   HUDStateSet->setMode(GL_DEPTH_TEST,osg::StateAttribute::OFF);
   HUDStateSet->setRenderingHint( osg::StateSet::TRANSPARENT_BIN );

   HUDStateSet2->setMode(GL_DEPTH_TEST,osg::StateAttribute::OFF);
   HUDStateSet2->setRenderingHint( osg::StateSet::TRANSPARENT_BIN );

   HUDStateSet3->setMode(GL_DEPTH_TEST,osg::StateAttribute::OFF);
   HUDStateSet3->setRenderingHint( osg::StateSet::TRANSPARENT_BIN );

   // Need to make sure this geometry is drawn last. RenderBins are handled
   // in numerical order so set bin number to 11
   HUDStateSet->setRenderBinDetails( 99, "RenderBin");
   HUDStateSet2->setRenderBinDetails( 98, "RenderBin");
   HUDStateSet2->setRenderBinDetails( 97, "RenderBin");
   // set global geode pointers for use in Keyboard event calls
   MyGeode = HUDGeode;
   MyGeode2 = HUDGeode2;

   // Declare a box class (derived from shape class) instance
   // This constructor takes an osg::Vec3 to define the center
   //  and a float to define the height, width and depth.
   //  (an overloaded constructor allows you to specify unique
   //   height, width and height values.)
   osg::Box* unitCube = new osg::Box( osg::Vec3(0,0,0), 5.0f, 0.01f, 2.5f);
   unitCube->setDataVariance(osg::Object::DYNAMIC);

   // Declare an instance of the shape drawable class and initialize 
   //  it with the unitCube shape we created above.
   //  This class is derived from 'drawable' so instances of this
   //  class can be added to Geode instances.
   osg::ShapeDrawable* unitCubeDrawable = new osg::ShapeDrawable(unitCube);

   // Declare a instance of the geode class: 
   osg::Geode* basicShapesGeode = new osg::Geode();

   // Add the unit cube drawable to the geode:
   basicShapesGeode->addDrawable(unitCubeDrawable);

   // Add the goede to the scene:
   root->addChild(basicShapesGeode);
  

   //osg::Texture2D* KLN89FaceTexture = new osg::Texture2D;
   //osg::setNotifyLevel(osg::DEBUG_INFO);

   // protect from being optimized away as static state:
   KLN89FaceTexture->setDataVariance(osg::Object::DYNAMIC); 
   //osg::Image* klnFace = osgDB::readImageFile("KLN89FaceB.tga");
   osg::Image* klnFace = osgDB::readImageFile("b:\\mg.jpg");
   if (!klnFace)
   {
      std::cout << " couldn't load texture, quitting." << std::endl;
      //return -1;
   }
    
   KLN89FaceTexture->setImage(klnFace);

   // Declare a state set for 'BLEND' texture mode
   osg::StateSet* blendStateSet = new osg::StateSet();

   // Declare a TexEnv instance, set the mode to 'BLEND'
   osg::TexEnv* blendTexEnv = new osg::TexEnv;
   blendTexEnv->setMode(osg::TexEnv::BLEND);
   

   // Turn the attribute of texture 0 'ON'
   blendStateSet->setTextureAttributeAndModes(0,KLN89FaceTexture,osg::StateAttribute::ON);
   // Set the texture texture environment for texture 0 to the 
   //  texture envirnoment we declared above:
   blendStateSet->setTextureAttribute(0,blendTexEnv);

   osg::StateSet* decalStateSet = new osg::StateSet();
   osg::TexEnv* decalTexEnv = new osg::TexEnv();
   decalTexEnv->setMode(osg::TexEnv::DECAL);

   decalStateSet->setTextureAttributeAndModes(0,KLN89FaceTexture,osg::StateAttribute::ON);
   decalStateSet->setTextureAttribute(0,decalTexEnv);

   basicShapesGeode->setStateSet(blendStateSet);
   
//  Set up camera(s)
   osg::GraphicsContext::WindowingSystemInterface* wsi = osg::GraphicsContext::getWindowingSystemInterface();
	unsigned int width, height;
    wsi->getScreenResolution(osg::GraphicsContext::ScreenIdentifier(0), width, height);
	
	osg::ref_ptr<osg::GraphicsContext::Traits> traits = new osg::GraphicsContext::Traits;
	traits->screenNum = 0;
    traits->x = 500;
    traits->y = 30;
    traits->width = 1000;
    traits->height = 1000;
    traits->windowDecoration = true;
    traits->doubleBuffer = true;
    traits->sharedContext = 0;

    osg::ref_ptr<osg::GraphicsContext> gc = osg::GraphicsContext::createGraphicsContext(traits.get());
    if (gc.valid())
    {
        osg::notify(osg::INFO)<<"  GraphicsWindow has been created successfully."<<std::endl;

        // need to ensure that the window is cleared make sure that the complete window is set the correct colour
        // rather than just the parts of the window that are under the camera's viewports
        gc->setClearColor(osg::Vec4f(0.2f,0.2f,0.6f,1.0f));
        gc->setClearMask(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    }
    else
    {
        osg::notify(osg::NOTICE)<<"  GraphicsWindow has not been created successfully."<<std::endl;
    }

	mainCamera->setGraphicsContext(gc.get());
	mainCamera->setViewport(new osg::Viewport(0,0, 1000,1000));
	
	GLenum buffer = traits->doubleBuffer ? GL_BACK : GL_FRONT;
    mainCamera->setDrawBuffer(buffer);
    mainCamera->setReadBuffer(buffer);

	Tman1->setDataVariance(osg::Object::DYNAMIC);
	view1 = createViewNew (&viewer,root,gc,Tman1,   0,  0, traits->width,traits->height); //normal view
	
	view1->setDataVariance(osg::Object::DYNAMIC);
	viewer.setDataVariance(osg::Object::DYNAMIC);

    view1->setSceneData( root );

 // Keyboard handlers
 //  keyboardEventHandler* keh_l = new keyboardEventHandler();
 //  keh_l->addFunction('l',LockOrUnlock);
 //  viewer.getEventHandlerList().push_front(keh_l); 

//  variables for getting local time
   time_t currentTime;
   tm localTime;
   time(&currentTime); // get current time_t value
   localTime=*(localtime(&currentTime)); // dereference and assign
   int timeUpdateCounter = 0;  // counter to determine when to update HUD clock

   // add callback that gets jpeg image via ACE udp multicast
   
   //mainCamera->setPostDrawCallback( new CaptureImageCallback );
   

   viewer.realize();

   long iUpdateCount = 0;

   //SnapImage* postDrawCallback = new SnapImage("PostDrawCallback.jpg");
   SnapImage* postDrawCallback = new SnapImage();
   view1->getCamera()->setPreDrawCallback(postDrawCallback);
  
   // main osg render loop
   while( !viewer.done() )
   {
      
	  if (timeUpdateCounter%5 == 0) {  // only update every 50th frame so as not to kill framerate on graphics
	    time(&currentTime);                   // get current time_t value
		localTime=*(localtime(&currentTime)); // dereference and assign

		sprintf(tempstr,"%3d:%2d:%2d:%2d.%3d",localTime.tm_yday,localTime.tm_hour,localTime.tm_min,localTime.tm_sec,timeUpdateCounter%1000);
		textOne->setText(tempstr);
	  }

	  // get TENA variables each loop
	  UpdateTSPI();

	  if (bResignOSG) viewer.setDone(true);

      viewer.frame();
   } 
   return ;
}

// Routine to read in OSG terrain and UUT model and path information
// Mike Greene  -  Trideum Corp.   July 17,2007
//  (256)  704-6113
void ReadInXMLInfo()
{
	 // this opens and parses the XML file:
	XMLNode xMainNode=XMLNode::openFileHelper("TASconfig.xml","MGXML");

    XMLNode xNode=xMainNode.getChildNode("terrainfile");
	sXMLTerrainFileName = std::string(xNode.getText());

	xNode=xMainNode.getChildNode("vehiclefile");
	sXMLVehicleFileName = std::string(xNode.getText());

	xNode=xMainNode.getChildNode("xoffset");
	xOffsetToZero = atof(xNode.getText());

	xNode=xMainNode.getChildNode("yoffset");
	yOffsetToZero = atof(xNode.getText());

	xNode=xMainNode.getChildNode("zoffset");
	zOffsetToZero = atof(xNode.getText());

	xNode=xMainNode.getChildNode("multicast_address");
	sXMLMulticastAddress = std::string(xNode.getText());

	xNode=xMainNode.getChildNode("ramdisk");
	sXMLRamdisk = std::string(xNode.getText());

	xNode=xMainNode.getChildNode("symbolsIBAS");
	sXMLSymbolsIBAS = std::string(xNode.getText());

	xNode=xMainNode.getChildNode("reticule");
	sXMLReticule = std::string(xNode.getText());

	// find number of "modelpath" tags
	int np=xMainNode.nChildNode("modelpath");
	

	int j, polyIterator=0;
	for (j=0 ; j < np; j++)
	{
		// this gets the number data from the "path" tags and pushes them onto the search list:
		
		xNode = xMainNode.getChildNode("modelpath",&polyIterator).getChildNode("path");
		pathList.push_back(xNode.getText());	
	}
    
}